/*******************************************************************************
 *
 * blueMarine - open source photo workflow
 * =======================================
 *
 * Copyright (C) 2003-2010 by Fabrizio Giudici
 * Project home page: http://bluemarine.tidalwave.it
 *
 *******************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 *******************************************************************************
 *
 * $Id: VisualSemanticController.java,v 213fe927a495 2010/01/01 00:36:29 fabrizio $
 *
 ******************************************************************************/
package it.tidalwave.semantic.graph;

import java.util.Set;
import javax.annotation.Nonnull;
import it.tidalwave.semantic.other.Entity;
import org.netbeans.api.visual.widget.ConnectionWidget;
import org.netbeans.api.visual.widget.Scene;
import org.netbeans.api.visual.widget.Widget;
import org.openide.nodes.Node;

/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: VisualSemanticController.java,v 213fe927a495 2010/01/01 00:36:29 fabrizio $
 *
 ******************************************************************************/
public interface VisualSemanticController
  {
    /***************************************************************************
     *
     *
     **************************************************************************/
    public static interface EntityWidgetFactory
      {
        public Widget createWidget (@Nonnull Scene scene,
                                    @Nonnull Node node);
      }

    /***************************************************************************
     *
     *
     **************************************************************************/
    public static interface RelationWidgetFactory
      {
        public ConnectionWidget createWidget (@Nonnull Scene scene,
                                              @Nonnull Node node);
      }

    /***************************************************************************
     *
     *
     **************************************************************************/
    public void addEntities (@Nonnull Set<Entity> entities);

    /***************************************************************************
     *
     *
     **************************************************************************/
    public void clean();
  }
