/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package it.tidalwave.semantic.graph.impl;

import it.tidalwave.netbeans.visual.NodeScene;
import java.awt.event.ActionEvent;
import javax.annotation.Nonnull;
import javax.swing.AbstractAction;
import org.netbeans.api.visual.graph.layout.GraphLayout;
import org.netbeans.api.visual.graph.layout.GraphLayoutFactory;
import org.netbeans.api.visual.graph.layout.GraphLayoutSupport;
import org.netbeans.api.visual.layout.LayoutFactory;
import org.netbeans.api.visual.layout.SceneLayout;
import org.openide.nodes.Node;

public final class ApplyTreeLayoutAction extends AbstractAction
  {
    @Nonnull
    private final ViewerFilterNode node;

    public ApplyTreeLayoutAction (ViewerFilterNode node)
      {
        this.node = node;
        putValue(NAME, "Apply tree layout");
      }

    public void actionPerformed (ActionEvent event)
      {
        GraphLayout<Node, Node> graphLayout = GraphLayoutFactory.createTreeGraphLayout(100, 100, 50, 50, true);
        GraphLayoutSupport.setTreeGraphLayoutRootNode(graphLayout, node);
        final NodeScene scene = node.getLookup().lookup(NodeScene.class);
        final SceneLayout sceneGraphLayout = LayoutFactory.createSceneGraphLayout(scene, graphLayout);
        sceneGraphLayout.invokeLayoutImmediately();
      }
  }

